.ifndef _DEVA_LCD_INC
_DEVA_LCD_INC .EQU 1
.include func.inc

;
LCD_Command_Addr	EQU	08000H
LCD_Data_Addr	EQU	0C000H
LCD_CS_Drr	EQU	00140H		; Select /CS3/PB2

.ifdef _RGBFORMAT
;MADCTRL ENUM VALUE
ROTATE_0		.equ 00H
ROTATE_90		.equ 60H
ROTATE_180		.equ C0H
ROTATE_270		.equ A0H
ROTATE_MIR_0	.equ 80H
ROTATE_MIR_90	.equ 20H
ROTATE_MIR_180	.equ 40H
ROTATE_MIR_270	.equ E0H
;SCANDIR ENUM VALUE
SC_DOWNRIGHT	.equ C8H
SC_DOWNLEFT	.equ 88H
SC_UPRIGHT		.equ 48H
SC_UPLEFT		.equ 08H
.else
;MADCTRL ENUM VALUE
ROTATE_0		.equ 08H
ROTATE_90		.equ 68H
ROTATE_180		.equ C8H
ROTATE_270		.equ A8H
ROTATE_MIR_0	.equ 88H
ROTATE_MIR_90	.equ 28H
ROTATE_MIR_180	.equ 48H
ROTATE_MIR_270	.equ E8H
;SCANDIR ENUM VALUE
SC_DOWNRIGHT	.equ C0H
SC_DOWNLEFT	.equ 80H
SC_UPRIGHT		.equ 40H
SC_UPLEFT		.equ 00H
.endif
;
_DrawBlock macro cx,cy,cxend,cyend,sizeL,sizeH,ddsrc
	;Set Lcd addr
	MOV	#<LCD_CS_Drr,<DRRL
	MOV	#>LCD_CS_Drr,<DRRH
	MOV	#2AH,LCD_Command_Addr
	MOV #0,LCD_Data_Addr
	MOV	cx,LCD_Data_Addr
	MOV #0,LCD_Data_Addr
	MOV	cxend,LCD_Data_Addr
	MOV	#2BH,LCD_Command_Addr
	MOV #0,LCD_Data_Addr
	MOV	cy,LCD_Data_Addr
	MOV #0,LCD_Data_Addr
	MOV	cyend,LCD_Data_Addr
	;WRITE LCD RAM BEGIN
	MOV #2CH,LCD_Command_Addr
	;
	;dma
	MOV	#08H,<DMOD
	MOV	#04H,<DCTR
	MOV	#<ddsrc,<DPTRL
	MOV	#>ddsrc,<DPTRH
	MOV	#<^ddsrc,<DBKRL
	MOV	#>^ddsrc,<DBKRH
;	MOV	#<8000H,<DBKRL	;
;	MOV	#>8000H,<DBKRH	;internal ram
	MOV	#05H,<DCTR
	MOV	#<LCD_CS_Drr,<DBKRL
	MOV	#>LCD_CS_Drr,<DBKRH
	MOV	#<LCD_Data_Addr,<DPTRL
	MOV	#>LCD_Data_Addr,<DPTRH
	MOV	sizeL,<DCNTL
	MOV	sizeH,<DCNTH
	MOV #00H,LCD_Command_Addr	;lcd command nop
	endm
	;rwcolor:words in ram,not work perfectly
_FillBlock macro cx,cy,cxend,cyend,sizeL,sizeH,colorL,colorH
	;Set Lcd addr
	MOV	#<LCD_CS_Drr,<DRRL
	MOV	#>LCD_CS_Drr,<DRRH
	MOV	#2AH,LCD_Command_Addr
	MOV #0,LCD_Data_Addr
	MOV	cx,LCD_Data_Addr
	MOV #0,LCD_Data_Addr
	MOV	cxend,LCD_Data_Addr
	MOV	#2BH,LCD_Command_Addr
	MOV #0,LCD_Data_Addr
	MOV	cy,LCD_Data_Addr
	MOV #0,LCD_Data_Addr
	MOV	cyend,LCD_Data_Addr
	;WRITE LCD RAM BEGIN
	MOV #2CH,LCD_Command_Addr

	;dma
	;MOV	#09H,<DMOD		;source:reload mode,dest:fix mode
	MOV	#0AH,<DMOD		;source:fix mode,dest:fix mode
	MOV	#04H,<DCTR
	MOV16	colorL,colorH,<wp,<wp+1
	MOV	#<wp,<DPTRL
	MOV	#>wp,<DPTRH
	MOV16	#<$8000,#>$8000,<DBKRL,<DBKRH	;internal ram
	;STZ	<DBKRL
	;STZ	<DBKRH
	MOV	#05H,<DCTR
	MOV	#<LCD_CS_Drr,<DBKRL
	MOV	#>LCD_CS_Drr,<DBKRH
	MOV	#<LCD_Data_Addr,<DPTRL
	MOV	#>LCD_Data_Addr,<DPTRH
	MOV	sizeL,<DCNTL
	MOV	sizeH,<DCNTH
	;
;	MOV16	#1,#0,<DCNTL,<DCNTH
;	MOV16	sizeL,sizeH,<wb,<wb+1
;?_REPEAT#
;	SMB7 <DCNTH
;	DEC16 <wb,<wb+1
;	CMP16_NEQ #0,#0,<wb,<wb+1,?_REPEAT#
	MOV #00H,LCD_Command_Addr	;lcd command nop
	endm
	
_SetBrightness macro var
	MOV	var,<PDAC
	endm
	
__InitLCD macro
	_FUNCTION F_InitLCD
	endm
__SetScanDir macro cval
	_FUNCTION_c F_SetLcdScanDir,cval
	endm
__SetMadCtl macro cval
	_FUNCTION_c F_SetLcdMadCtl,cval
	endm
__SetContrast macro cval
	_FUNCTION_c F_SetLcdContrast,cval
	endm
__LcdEnterSleep macro
	_FUNCTION F_LcdEnterSleep
	endm
__LcdExitSleep macro
	_FUNCTION F_LcdExitSleep
	endm
.endif

